diff --git a/.gitignore b/.gitignore
index 43e21fd8..5942f401 100644
--- a/.gitignore
+++ b/.gitignore
@@ -1,8 +1,8 @@
 .DS_Store
 node_modules/*
 yarn.lock
-tesseract.dev.js
-worker.dev.js
+tesseract.min.js
+worker.min.js
 *.traineddata
 *.traineddata.gz
 .nyc_output
diff --git a/benchmarks/node/speed-benchmark.js b/benchmarks/node/speed-benchmark.js
index 68ebd29c..8da5dab1 100644
--- a/benchmarks/node/speed-benchmark.js
+++ b/benchmarks/node/speed-benchmark.js
@@ -1,11 +1,9 @@
 #!/usr/bin/env node
-const path = require('node:path');
+const path = require('path');
 const { createWorker } = require('../../');
 
 (async () => {
   const worker = await createWorker();
-  await worker.loadLanguage('eng');
-  await worker.initialize('eng');
   const fileArr = ["../data/meditations.jpg", "../data/tyger.jpg", "../data/testocr.png"];
   let timeTotal = 0;
   for (let file of fileArr) {
diff --git a/examples/node/download-pdf.js b/examples/node/download-pdf.js
index f12d8174..8835c8a3 100755
--- a/examples/node/download-pdf.js
+++ b/examples/node/download-pdf.js
@@ -1,6 +1,6 @@
 #!/usr/bin/env node
-const path = require('node:path');
-const fs = require('node:fs');
+const path = require('path');
+const fs = require('fs');
 const { createWorker } = require('../../');
 
 const [,, imagePath] = process.argv;
@@ -10,8 +10,6 @@ console.log(`Recognizing ${image}`);
 
 (async () => {
   const worker = await createWorker();
-  await worker.loadLanguage('eng');
-  await worker.initialize('eng');
   const { data: { text, pdf } } = await worker.recognize(image, {pdfTitle: "Example PDF"}, {pdf: true});
   console.log(text);
   fs.writeFileSync('tesseract-ocr-result.pdf', Buffer.from(pdf));
diff --git a/examples/node/image-processing.js b/examples/node/image-processing.js
index 9de7d9ab..351575bd 100755
--- a/examples/node/image-processing.js
+++ b/examples/node/image-processing.js
@@ -1,6 +1,6 @@
 #!/usr/bin/env node
-const path = require('node:path');
-const fs = require('node:fs');
+const path = require('path');
+const fs = require('fs');
 const { createWorker } = require('../../');
 
 const [,, imagePath] = process.argv;
@@ -21,8 +21,6 @@ const convertImage = (imageSrc) => {
 
 (async () => {
   const worker = await createWorker();
-  await worker.loadLanguage('eng');
-  await worker.initialize('eng');
   const { data: { imageColor, imageGrey, imageBinary } } = await worker.recognize(image, {rotateAuto: true}, {imageColor: true, imageGrey: true, imageBinary: true});
   
   console.log('Saving intermediate images: imageColor.png, imageGrey.png, imageBinary.png');
diff --git a/examples/node/recognize.js b/examples/node/recognize.js
index a01b333e..03754d35 100755
--- a/examples/node/recognize.js
+++ b/examples/node/recognize.js
@@ -1,5 +1,5 @@
 #!/usr/bin/env node
-const path = require('node:path');
+const path = require('path');
 const { createWorker } = require('../../');
 
 const [,, imagePath] = process.argv;
@@ -8,11 +8,9 @@ const image = path.resolve(__dirname, (imagePath || '../../tests/assets/images/c
 console.log(`Recognizing ${image}`);
 
 (async () => {
-  const worker = await createWorker({
+  const worker = await createWorker("eng", 1, {
     logger: m => console.log(m),
   });  
-  await worker.loadLanguage('eng');
-  await worker.initialize('eng');
   const { data: { text } } = await worker.recognize(image);
   console.log(text);
   await worker.terminate();
diff --git a/examples/node/scheduler.js b/examples/node/scheduler.js
index 43afb87c..d386b6a2 100755
--- a/examples/node/scheduler.js
+++ b/examples/node/scheduler.js
@@ -1,12 +1,19 @@
 const { createWorker, createScheduler } = require('../../');
+const path = require('path');
+const [,, imagePath] = process.argv;
+
+// Note: This example recognizes the same image 4 times in parallel 
+// to show how schedulers can be used to speed up bulk jobs.
+// In actual use you would (obviously) not want to run multiple identical jobs. 
+
+const image = path.resolve(__dirname, (imagePath || '../../tests/assets/images/cosmic.png'));
+const imageArr = [image, image, image, image];
 
 const scheduler = createScheduler();
 
 // Creates worker and adds to scheduler
 const workerGen = async () => {
-  const worker = await createWorker({cachePath: "."});
-  await worker.loadLanguage('eng');
-  await worker.initialize('eng');
+  const worker = await createWorker("eng", 1, {cachePath: "."});
   scheduler.addWorker(worker);
 }
 
@@ -14,12 +21,17 @@ const workerN = 4;
 (async () => {
   const resArr = Array(workerN);
   for (let i=0; i<workerN; i++) {
-    resArr[i] = await workerGen();
+    resArr[i] = workerGen();
   }
   await Promise.all(resArr);
-  /** Add 4 recognition jobs */
-  const results = await Promise.all(Array(10).fill(0).map(() => (
-    scheduler.addJob('recognize', 'https://tesseract.projectnaptha.com/img/eng_bw.png').then((x) => console.log(x.data.text))
-  )))
+
+  const resArr2 = Array(imageArr.length);
+
+  for (let i = 0; i < imageArr.length; i++) {
+    resArr2[i] = scheduler.addJob('recognize', image).then((x) => console.log(x.data.text));
+  }
+
+  await Promise.all(resArr2);
+
   await scheduler.terminate(); // It also terminates all workers.
 })();
\ No newline at end of file
diff --git a/scripts/server.js b/scripts/server.js
index a53052a0..77a3d1ef 100644
--- a/scripts/server.js
+++ b/scripts/server.js
@@ -1,9 +1,9 @@
 const webpack = require('webpack');
 const middleware = require('webpack-dev-middleware');
 const express = require('express');
-const path = require('node:path');
+const path = require('path');
 const cors = require('cors');
-const webpackConfig = require('./webpack.config.dev');
+const webpackConfig = require('./webpack.config.prod');
 
 const compiler = webpack(webpackConfig);
 const app = express();
diff --git a/scripts/test-helper.js b/scripts/test-helper.js
index 3a2b3975..027b3006 100644
--- a/scripts/test-helper.js
+++ b/scripts/test-helper.js
@@ -1,7 +1,7 @@
 const constants = require('../tests/constants');
 global.expect = require('expect.js');
-global.fs = require('node:fs');
-global.path = require('node:path');
+global.fs = require('fs');
+global.path = require('path');
 global.Tesseract = require('../src');
 
 Object.keys(constants).forEach((key) => {
diff --git a/scripts/webpack.config.prod.js b/scripts/webpack.config.prod.js
index b92d5e3a..e581df7a 100644
--- a/scripts/webpack.config.prod.js
+++ b/scripts/webpack.config.prod.js
@@ -1,4 +1,4 @@
-const path = require('node:path');
+const path = require('path');
 const common = require('./webpack.config.common');
 const webpack = require('webpack');
 
diff --git a/src/Tesseract.js b/src/Tesseract.js
index 95396743..50200254 100644
--- a/src/Tesseract.js
+++ b/src/Tesseract.js
@@ -1,9 +1,7 @@
 const createWorker = require('./createWorker');
 
 const recognize = async (image, langs, options) => {
-  const worker = await createWorker(options);
-  await worker.loadLanguage(langs);
-  await worker.initialize(langs);
+  const worker = await createWorker(langs, 1, options);
   return worker.recognize(image)
     .finally(async () => {
       await worker.terminate();
@@ -11,9 +9,7 @@ const recognize = async (image, langs, options) => {
 };
 
 const detect = async (image, options) => {
-  const worker = await createWorker(options);
-  await worker.loadLanguage('osd');
-  await worker.initialize('osd');
+  const worker = await createWorker('osd', 0, options);
   return worker.detect(image)
     .finally(async () => {
       await worker.terminate();
diff --git a/src/constants/defaultOptions.js b/src/constants/defaultOptions.js
index e4254203..af875f6c 100644
--- a/src/constants/defaultOptions.js
+++ b/src/constants/defaultOptions.js
@@ -1,8 +1,4 @@
 module.exports = {
-  /*
-   * default path for downloading *.traineddata
-   */
-  langPath: 'https://tessdata.projectnaptha.com/4.0.0',
   /*
    * Use BlobURL for worker script by default
    * TODO: remove this option
diff --git a/src/createWorker.js b/src/createWorker.js
index 8fbd426b..d3568086 100644
--- a/src/createWorker.js
+++ b/src/createWorker.js
@@ -3,7 +3,7 @@ const circularize = require('./utils/circularize');
 const createJob = require('./createJob');
 const { log } = require('./utils/log');
 const getId = require('./utils/getId');
-const { defaultOEM } = require('./constants/config');
+const OEM = require('./constants/OEM');
 const {
   defaultOptions,
   spawnWorker,
@@ -15,7 +15,7 @@ const {
 
 let workerCounter = 0;
 
-module.exports = async (_options = {}) => {
+module.exports = async (langs = 'eng', oem = OEM.LSTM_ONLY, _options = {}, config = {}) => {
   const id = getId('Worker', workerCounter);
   const {
     logger,
@@ -28,6 +28,13 @@ module.exports = async (_options = {}) => {
   const resolves = {};
   const rejects = {};
 
+  // Current langs, oem, and config file.
+  // Used if the user ever re-initializes the worker using `worker.reinitialize`.
+  const currentLangs = typeof langs === 'string' ? langs.split('+') : langs;
+  let currentOem = oem;
+  let currentConfig = config;
+  const lstmOnlyCore = [OEM.DEFAULT, OEM.LSTM_ONLY].includes(oem) && !options.legacyCore;
+
   let workerResReject;
   let workerResResolve;
   const workerRes = new Promise((resolve, reject) => {
@@ -69,7 +76,7 @@ module.exports = async (_options = {}) => {
 
   const loadInternal = (jobId) => (
     startJob(createJob({
-      id: jobId, action: 'load', payload: { options },
+      id: jobId, action: 'load', payload: { options: { lstmOnly: lstmOnlyCore, corePath: options.corePath, logging: options.logging } },
     }))
   );
 
@@ -105,22 +112,62 @@ module.exports = async (_options = {}) => {
     }))
   );
 
-  const loadLanguage = (langs = 'eng', jobId) => (
-    startJob(createJob({
-      id: jobId,
-      action: 'loadLanguage',
-      payload: { langs, options },
-    }))
+  const loadLanguage = () => (
+    console.warn('`loadLanguage` is depreciated and should be removed from code (workers now come with language pre-loaded)')
   );
 
-  const initialize = (langs = 'eng', oem = defaultOEM, config, jobId) => (
+  const loadLanguageInternal = (_langs, jobId) => startJob(createJob({
+    id: jobId,
+    action: 'loadLanguage',
+    payload: {
+      langs: _langs,
+      options: {
+        langPath: options.langPath,
+        dataPath: options.dataPath,
+        cachePath: options.cachePath,
+        cacheMethod: options.cacheMethod,
+        gzip: options.gzip,
+        lstmOnly: [OEM.TESSERACT_ONLY, OEM.TESSERACT_LSTM_COMBINED].includes(currentOem)
+          && !options.legacyLang,
+      },
+    },
+  }));
+
+  const initialize = () => (
+    console.warn('`initialize` is depreciated and should be removed from code (workers now come pre-initialized)')
+  );
+
+  const initializeInternal = (_langs, _oem, _config, jobId) => (
     startJob(createJob({
       id: jobId,
       action: 'initialize',
-      payload: { langs, oem, config },
+      payload: { langs: _langs, oem: _oem, config: _config },
     }))
   );
 
+  const reinitialize = (langs = 'eng', oem, config, jobId) => { // eslint-disable-line
+
+    if (lstmOnlyCore && [OEM.TESSERACT_ONLY, OEM.TESSERACT_LSTM_COMBINED].includes(oem)) throw Error('Legacy model requested but code missing.');
+
+    const _oem = oem || currentOem;
+    currentOem = _oem;
+
+    const _config = config || currentConfig;
+    currentConfig = _config;
+
+    // Only load langs that are not already loaded.
+    // This logic fails if the user downloaded the LSTM-only English data for a language
+    // and then uses `worker.reinitialize` to switch to the Legacy engine.
+    // However, the correct data will still be downloaded after initialization fails
+    // and this can be avoided entirely
+    const langsArr = typeof langs === 'string' ? langs.split('+') : langs;
+    const _langs = langsArr.filter((x) => currentLangs.includes(x));
+    currentLangs.push(_langs);
+
+    return loadLanguageInternal(_langs, jobId)
+      .then(() => initializeInternal(_langs, _oem, _config, jobId));
+  };
+
   const setParameters = (params = {}, jobId) => (
     startJob(createJob({
       id: jobId,
@@ -148,13 +195,15 @@ module.exports = async (_options = {}) => {
     }));
   };
 
-  const detect = async (image, jobId) => (
-    startJob(createJob({
+  const detect = async (image, jobId) => {
+    if (lstmOnlyCore) throw Error('`worker.detect` requires Legacy model, which was not loaded.');
+
+    return startJob(createJob({
       id: jobId,
       action: 'detect',
       payload: { image: await loadImage(image) },
-    }))
-  );
+    }));
+  };
 
   const terminate = async () => {
     if (worker !== null) {
@@ -207,6 +256,7 @@ module.exports = async (_options = {}) => {
     FS,
     loadLanguage,
     initialize,
+    reinitialize,
     setParameters,
     recognize,
     getPDF,
@@ -214,7 +264,11 @@ module.exports = async (_options = {}) => {
     terminate,
   };
 
-  loadInternal().then(() => workerResResolve(resolveObj)).catch(() => {});
+  loadInternal()
+    .then(() => loadLanguageInternal(langs))
+    .then(() => initializeInternal(langs, oem, config))
+    .then(() => workerResResolve(resolveObj))
+    .catch(() => {});
 
   return workerRes;
 };
diff --git a/src/index.d.ts b/src/index.d.ts
index 58598e8d..3171780c 100644
--- a/src/index.d.ts
+++ b/src/index.d.ts
@@ -1,6 +1,6 @@
 declare namespace Tesseract {
   function createScheduler(): Scheduler
-  function createWorker(options?: Partial<WorkerOptions>): Promise<Worker>
+  function createWorker(langs?: string | Lang[], oem?: OEM, options?: Partial<WorkerOptions>, config?: string | Partial<InitOptions>): Promise<Worker>
   function setLogging(logging: boolean): void
   function recognize(image: ImageLike, langs?: string, options?: Partial<WorkerOptions>): Promise<RecognizeResult>
   function detect(image: ImageLike, options?: Partial<WorkerOptions>): any
@@ -20,8 +20,7 @@ declare namespace Tesseract {
     readText(path: string, jobId?: string): Promise<ConfigResult>
     removeText(path: string, jobId?: string): Promise<ConfigResult>
     FS(method: string, args: any[], jobId?: string): Promise<ConfigResult>
-    loadLanguage(langs?: string | Lang[], jobId?: string): Promise<ConfigResult>
-    initialize(langs?: string | Lang[], oem?: OEM, config?: string | Partial<InitOptions>, jobId?: string): Promise<ConfigResult>
+    reinitialize(langs?: string | Lang[], oem?: OEM, config?: string | Partial<InitOptions>, jobId?: string): Promise<ConfigResult>
     setParameters(params: Partial<WorkerParams>, jobId?: string): Promise<ConfigResult>
     getImage(type: imageType): string
     recognize(image: ImageLike, options?: Partial<RecognizeOptions>, output?: Partial<OutputFormats>, jobId?: string): Promise<RecognizeResult>
@@ -61,6 +60,8 @@ declare namespace Tesseract {
     cacheMethod: string
     workerBlobURL: boolean
     gzip: boolean
+    legacyLang: boolean
+    legacyCore: boolean
     logger: (arg: LoggerMessage) => void,
     errorHandler: (arg: any) => void
   }
diff --git a/src/worker-script/browser/getCore.js b/src/worker-script/browser/getCore.js
index dad1e096..0b367f54 100644
--- a/src/worker-script/browser/getCore.js
+++ b/src/worker-script/browser/getCore.js
@@ -1,9 +1,11 @@
 const { simd } = require('wasm-feature-detect');
 const { dependencies } = require('../../../package.json');
 
-module.exports = async (corePath, res) => {
+module.exports = async (lstmOnly, corePath, res) => {
   if (typeof global.TesseractCore === 'undefined') {
-    res.progress({ status: 'loading tesseract core', progress: 0 });
+    const statusText = 'loading tesseract core';
+
+    res.progress({ status: statusText, progress: 0 });
 
     // If the user specifies a core path, we use that
     // Otherwise, default to CDN
@@ -19,7 +21,13 @@ module.exports = async (corePath, res) => {
     } else {
       const simdSupport = await simd();
       if (simdSupport) {
-        corePathImportFile = `${corePathImport.replace(/\/$/, '')}/tesseract-core-simd.wasm.js`;
+        if (lstmOnly) {
+          corePathImportFile = `${corePathImport.replace(/\/$/, '')}/tesseract-core-simd-lstm.wasm.js`;
+        } else {
+          corePathImportFile = `${corePathImport.replace(/\/$/, '')}/tesseract-core-simd.wasm.js`;
+        }
+      } else if (lstmOnly) {
+        corePathImportFile = `${corePathImport.replace(/\/$/, '')}/tesseract-core-lstm.wasm.js`;
       } else {
         corePathImportFile = `${corePathImport.replace(/\/$/, '')}/tesseract-core.wasm.js`;
       }
@@ -36,7 +44,7 @@ module.exports = async (corePath, res) => {
     } else if (typeof global.TesseractCore === 'undefined') {
       throw Error('Failed to load TesseractCore');
     }
-    res.progress({ status: 'loading tesseract core', progress: 1 });
+    res.progress({ status: statusText, progress: 1 });
   }
   return global.TesseractCore;
 };
diff --git a/src/worker-script/index.js b/src/worker-script/index.js
index d5c3c672..4fe04c08 100644
--- a/src/worker-script/index.js
+++ b/src/worker-script/index.js
@@ -28,15 +28,19 @@ let api = null;
 let latestJob;
 let adapter = {};
 let params = defaultParams;
-let cachePathWorker;
-let cacheMethodWorker;
+let loadLanguageLangsWorker;
+let loadLanguageOptionsWorker;
+let dataFromCache = false;
 
-const load = async ({ workerId, jobId, payload: { options: { corePath, logging } } }, res) => {
+const load = async ({ workerId, jobId, payload: { options: { lstmOnly, corePath, logging } } }, res) => { // eslint-disable-line max-len
   setLogging(logging);
+
+  const statusText = 'initializing tesseract';
+
   if (!TessModule) {
-    const Core = await adapter.getCore(corePath, res);
+    const Core = await adapter.getCore(lstmOnly, corePath, res);
 
-    res.progress({ workerId, status: 'initializing tesseract', progress: 0 });
+    res.progress({ workerId, status: statusText, progress: 0 });
 
     Core({
       TesseractProgress(percent) {
@@ -49,7 +53,7 @@ const load = async ({ workerId, jobId, payload: { options: { corePath, logging }
       },
     }).then((tessModule) => {
       TessModule = tessModule;
-      res.progress({ workerId, status: 'initialized tesseract', progress: 1 });
+      res.progress({ workerId, status: statusText, progress: 1 });
       res.resolve({ loaded: true });
     });
   } else {
@@ -72,13 +76,26 @@ const loadLanguage = async ({
       cachePath,
       cacheMethod,
       gzip = true,
+      lstmOnly,
     },
   },
 },
 res) => {
-  // Remember cache options for later, as cache may be deleted if `initialize` fails
-  cachePathWorker = cachePath;
-  cacheMethodWorker = cacheMethod;
+  // Remember options for later, as cache may be deleted if `initialize` fails
+  loadLanguageLangsWorker = langs;
+  loadLanguageOptionsWorker = {
+    langPath,
+    dataPath,
+    cachePath,
+    cacheMethod,
+    gzip,
+    lstmOnly,
+  };
+
+  const statusText = 'loading language traineddata';
+
+  const langsArr = typeof langs === 'string' ? langs.split('+') : langs;
+  let progress = 0;
 
   const loadAndGunzipFile = async (_lang) => {
     const lang = typeof _lang === 'string' ? _lang : _lang.code;
@@ -94,8 +111,8 @@ res) => {
       const _data = await readCache(`${cachePath || '.'}/${lang}.traineddata`);
       if (typeof _data !== 'undefined') {
         log(`[${workerId}]: Load ${lang}.traineddata from cache`);
-        res.progress({ workerId, status: 'loading language traineddata (from cache)', progress: 0.5 });
         data = _data;
+        dataFromCache = true;
       } else {
         throw Error('Not found in cache');
       }
@@ -106,14 +123,19 @@ res) => {
       if (typeof _lang === 'string') {
         let path = null;
 
+        // If `langPath` if not explicitly set by the user, the jsdelivr CDN is used.
+        // Data supporting the Legacy model is only included if `lstmOnly` is not true.
+        // This saves a significant amount of data for the majority of users that use LSTM only.
+        const langPathDownload = langPath || (lstmOnly ? `https://cdn.jsdelivr.net/npm/@tesseract.js-data/${lang}/4.0.0_best_int` : `https://cdn.jsdelivr.net/npm/@tesseract.js-data/${lang}/4.0.0`);
+
         // For Node.js, langPath may be a URL or local file path
         // The is-url package is used to tell the difference
         // For the browser version, langPath is assumed to be a URL
-        if (env !== 'node' || isURL(langPath) || langPath.startsWith('moz-extension://') || langPath.startsWith('chrome-extension://') || langPath.startsWith('file://')) { /** When langPath is an URL */
-          path = langPath.replace(/\/$/, '');
+        if (env !== 'node' || isURL(langPathDownload) || langPathDownload.startsWith('moz-extension://') || langPathDownload.startsWith('chrome-extension://') || langPathDownload.startsWith('file://')) { /** When langPathDownload is an URL */
+          path = langPathDownload.replace(/\/$/, '');
         }
 
-        // langPath is a URL, fetch from server
+        // langPathDownload is a URL, fetch from server
         if (path !== null) {
           const fetchUrl = `${path}/${lang}.traineddata${gzip ? '.gz' : ''}`;
           const resp = await (env === 'webworker' ? fetch : adapter.fetch)(fetchUrl);
@@ -122,16 +144,19 @@ res) => {
           }
           data = new Uint8Array(await resp.arrayBuffer());
 
-        // langPath is a local file, read .traineddata from local filesystem
+        // langPathDownload is a local file, read .traineddata from local filesystem
         // (adapter.readCache is a generic file read function in Node.js version)
         } else {
-          data = await adapter.readCache(`${langPath}/${lang}.traineddata${gzip ? '.gz' : ''}`);
+          data = await adapter.readCache(`${langPathDownload}/${lang}.traineddata${gzip ? '.gz' : ''}`);
         }
       } else {
         data = _lang.data; // eslint-disable-line
       }
     }
 
+    progress += 0.5 / langsArr.length;
+    if (res) res.progress({ workerId, status: statusText, progress });
+
     // Check for gzip magic numbers (1F and 8B in hex)
     const isGzip = (data[0] === 31 && data[1] === 139) || (data[1] === 31 && data[0] === 139);
 
@@ -144,7 +169,7 @@ res) => {
         try {
           TessModule.FS.mkdir(dataPath);
         } catch (err) {
-          res.reject(err.toString());
+          if (res) res.reject(err.toString());
         }
       }
       TessModule.FS.writeFile(`${dataPath || '.'}/${lang}.traineddata`, data);
@@ -158,16 +183,19 @@ res) => {
         log(err.toString());
       }
     }
-    return Promise.resolve();
+
+    progress += 0.5 / langsArr.length;
+    // Make sure last progress message is 1 (not 0.9999)
+    if (Math.round(progress * 100) === 100) progress = 1;
+    if (res) res.progress({ workerId, status: statusText, progress });
   };
 
-  res.progress({ workerId, status: 'loading language traineddata', progress: 0 });
+  if (res) res.progress({ workerId, status: statusText, progress: 0 });
   try {
-    await Promise.all((typeof langs === 'string' ? langs.split('+') : langs).map(loadAndGunzipFile));
-    res.progress({ workerId, status: 'loaded language traineddata', progress: 1 });
-    res.resolve(langs);
+    await Promise.all(langsArr.map(loadAndGunzipFile));
+    if (res) res.resolve(langs);
   } catch (err) {
-    res.reject(err.toString());
+    if (res) res.reject(err.toString());
   }
 };
 
@@ -208,9 +236,11 @@ const initialize = async ({
     ? _langs
     : _langs.map((l) => ((typeof l === 'string') ? l : l.data)).join('+');
 
+  const statusText = 'initializing api';
+
   try {
     res.progress({
-      workerId, status: 'initializing api', progress: 0,
+      workerId, status: statusText, progress: 0,
     });
     if (api !== null) {
       api.End();
@@ -230,22 +260,55 @@ const initialize = async ({
     }
 
     api = new TessModule.TessBaseAPI();
-    const status = api.Init(null, langs, oem);
+    let status = api.Init(null, langs, oem);
     if (status === -1) {
       // Cache is deleted if initialization fails to avoid keeping bad data in cache
       // This assumes that initialization failing only occurs due to bad .traineddata,
       // this should be refined if other reasons for init failing are encountered.
-      if (['write', 'refresh', undefined].includes(cacheMethodWorker)) {
+      // The "if" condition skips this section if either (1) cache is disabled [so the issue
+      // is definitely unrelated to cached data] or (2) cache is set to read-only
+      // [so we do not have permission to make any changes].
+      if (['write', 'refresh', undefined].includes(loadLanguageOptionsWorker.cacheMethod)) {
         const langsArr = langs.split('+');
-        const delCachePromise = langsArr.map((lang) => adapter.deleteCache(`${cachePathWorker || '.'}/${lang}.traineddata`));
+        const delCachePromise = langsArr.map((lang) => adapter.deleteCache(`${loadLanguageOptionsWorker.cachePath || '.'}/${lang}.traineddata`));
         await Promise.all(delCachePromise);
+
+        // Check for the case when (1) data was loaded from the cache and
+        // (2) the data does not support the requested OEM.
+        // In this case, loadLanguage is re-run and initialization is attempted a second time.
+        // This is because `loadLanguage` has no mechanism for checking whether the cached data
+        // supports the requested model, so this only becomes apparent when initialization fails.
+
+        // Check for this error message:
+        // eslint-disable-next-line
+        // "Tesseract (legacy) engine requested, but components are not present in ./eng.traineddata!!""
+        // The .wasm build of Tesseract saves this message in a separate file
+        // (in addition to the normal debug file location).
+        const debugStr = TessModule.FS.readFile('/debugDev.txt', { encoding: 'utf8', flags: 'a+' });
+        if (dataFromCache && /components are not present/.test(debugStr)) {
+          log('Data from cache missing requested OEM model. Attempting to refresh cache with new language data.');
+          // In this case, language data is re-loaded
+          await loadLanguage({ workerId, payload: { langs: loadLanguageLangsWorker, options: loadLanguageOptionsWorker } }); // eslint-disable-line max-len
+          status = api.Init(null, langs, oem);
+          if (status === -1) {
+            log('Language data refresh failed.');
+            const delCachePromise2 = langsArr.map((lang) => adapter.deleteCache(`${loadLanguageOptionsWorker.cachePath || '.'}/${lang}.traineddata`));
+            await Promise.all(delCachePromise2);
+          } else {
+            log('Language data refresh successful.');
+          }
+        }
       }
+    }
+
+    if (status === -1) {
       res.reject('initialization failed');
     }
+
     params = defaultParams;
     await setParameters({ payload: { params } });
     res.progress({
-      workerId, status: 'initialized api', progress: 1,
+      workerId, status: statusText, progress: 1,
     });
     res.resolve();
   } catch (err) {
diff --git a/src/worker-script/node/cache.js b/src/worker-script/node/cache.js
index fd6bab6b..e04809e2 100644
--- a/src/worker-script/node/cache.js
+++ b/src/worker-script/node/cache.js
@@ -1,5 +1,5 @@
-const util = require('node:util');
-const fs = require('node:fs');
+const util = require('util');
+const fs = require('fs');
 
 module.exports = {
   readCache: util.promisify(fs.readFile),
diff --git a/src/worker-script/node/getCore.js b/src/worker-script/node/getCore.js
index 03469dd7..b86662ce 100644
--- a/src/worker-script/node/getCore.js
+++ b/src/worker-script/node/getCore.js
@@ -1,20 +1,29 @@
 const { simd } = require('wasm-feature-detect');
+const OEM = require('../../constants/OEM');
 
 let TesseractCore = null;
 /*
  * getCore is a sync function to load and return
  * TesseractCore.
  */
-module.exports = async (_, res) => {
+module.exports = async (oem, _, res) => {
   if (TesseractCore === null) {
+    const statusText = 'loading tesseract core';
+
     const simdSupport = await simd();
-    res.progress({ status: 'loading tesseract core', progress: 0 });
+    res.progress({ status: statusText, progress: 0 });
     if (simdSupport) {
-      TesseractCore = require('tesseract.js-core/tesseract-core-simd');
+      if ([OEM.DEFAULT, OEM.LSTM_ONLY].includes(oem)) {
+        TesseractCore = require('tesseract.js-core/tesseract-core-simd-lstm');
+      } else {
+        TesseractCore = require('tesseract.js-core/tesseract-core-simd');
+      }
+    } else if ([OEM.DEFAULT, OEM.LSTM_ONLY].includes(oem)) {
+      TesseractCore = require('tesseract.js-core/tesseract-core-lstm');
     } else {
       TesseractCore = require('tesseract.js-core/tesseract-core');
     }
-    res.progress({ status: 'loaded tesseract core', progress: 1 });
+    res.progress({ status: statusText, progress: 1 });
   }
   return TesseractCore;
 };
diff --git a/src/worker-script/node/gunzip.js b/src/worker-script/node/gunzip.js
index 40f32949..4f2e0e0c 100644
--- a/src/worker-script/node/gunzip.js
+++ b/src/worker-script/node/gunzip.js
@@ -1 +1 @@
-module.exports = require('node:zlib').gunzipSync;
+module.exports = require('zlib').gunzipSync;
diff --git a/src/worker-script/node/index.js b/src/worker-script/node/index.js
index fb187b05..c00dba73 100644
--- a/src/worker-script/node/index.js
+++ b/src/worker-script/node/index.js
@@ -9,7 +9,7 @@
  */
 
 const fetch = require('node-fetch');
-const { parentPort } = require('node:worker_threads');
+const { parentPort } = require('worker_threads');
 const worker = require('..');
 const getCore = require('./getCore');
 const gunzip = require('./gunzip');
diff --git a/src/worker/browser/defaultOptions.js b/src/worker/browser/defaultOptions.js
index feac58ff..886cdb40 100644
--- a/src/worker/browser/defaultOptions.js
+++ b/src/worker/browser/defaultOptions.js
@@ -1,4 +1,3 @@
-const resolveURL = (s) => (new URL(s, window.location.href)).href;
 const { version } = require('../../../package.json');
 const defaultOptions = require('../../constants/defaultOptions');
 
@@ -7,12 +6,5 @@ const defaultOptions = require('../../constants/defaultOptions');
  */
 module.exports = {
   ...defaultOptions,
-  workerPath: (typeof process !== 'undefined' && process.env.TESS_ENV === 'development')
-    ? resolveURL(`/dist/worker.dev.js?nocache=${Math.random().toString(36).slice(3)}`)
-    : `https://cdn.jsdelivr.net/npm/tesseract.js@v${version}/dist/worker.min.js`,
-  /*
-   * If browser doesn't support WebAssembly,
-   * load ASM version instead
-   */
-  corePath: null,
+  workerPath: `https://cdn.jsdelivr.net/npm/tesseract.js@v${version}/dist/worker.min.js`,
 };
diff --git a/src/worker/node/defaultOptions.js b/src/worker/node/defaultOptions.js
index 498714c4..053c1e3e 100644
--- a/src/worker/node/defaultOptions.js
+++ b/src/worker/node/defaultOptions.js
@@ -1,4 +1,4 @@
-const path = require('node:path');
+const path = require('path');
 const defaultOptions = require('../../constants/defaultOptions');
 
 /*
diff --git a/src/worker/node/loadImage.js b/src/worker/node/loadImage.js
index 07d684e8..0b5a660f 100644
--- a/src/worker/node/loadImage.js
+++ b/src/worker/node/loadImage.js
@@ -1,5 +1,5 @@
-const util = require('node:util');
-const fs = require('node:fs');
+const util = require('util');
+const fs = require('fs');
 const fetch = require('node-fetch');
 const isURL = require('is-url');
 
diff --git a/src/worker/node/spawnWorker.js b/src/worker/node/spawnWorker.js
index c26537d1..9723c183 100644
--- a/src/worker/node/spawnWorker.js
+++ b/src/worker/node/spawnWorker.js
@@ -1,4 +1,4 @@
-const { Worker } = require('node:worker_threads');
+const { Worker } = require('worker_threads');
 
 /**
  * spawnWorker
